%Programa que captura datos de un emisor de ultrasonidos resonante a 40KHz mediante un receptor de ultrasonidos resonante a 40KHz 
[notfound,warnings]=loadlibrary('ElabDLL.dll', 'ElabDLL.h')

%Configurar SISTEMA DE ADQUISICIN DE DATOS
disp(' Configuracin del sistema de adquisicin de datos')
intA = input('Set Ch1 mV/div. Possible values are 10, 20, 50, 100, 200, 500 \n'); 
intB= 500 ;
boolA= input('Set Ch1 DC(1)/AC(0) \n');
boolB=0;
boolC= input('Set Ch1 probe 10X(1)/1X(0) \n');
boolD=0;
ReturnSetAnalogChannels=calllib('ElabDLL', 'SetAnalogChannels', intA, intB, boolA, boolB, boolC, boolD);
doubleA=0;
doubleB=0;
ReturnSetDSODCOffsets=calllib('ElabDLL', 'SetDSODCOffsets', doubleA, doubleB);
doubleA=190000;
MuestreoAsignado=calllib('ElabDLL', 'SetDSOLASampleRate', doubleA);


%poner en marcha el GENERADOR DE FUNCIONES
Frecuency=40000; %frecuencia de la seal generada
PlayFrecuency=100000000; %frecuencia de muestreo o reproduccin
SamplesPlay=PlayFrecuency/Frecuency; %puntos por periodo
n=0:2*pi/SamplesPlay:2*pi; %Vector escalar con el numero de puntos por periodo
x=cos(n);%Datos a transmitir por el generador de funciones analgico
doublePtrA = libpointer('doublePtr', x); %analog data +-1.25V or +-5V
int16PtrA = libpointer('int16Ptr', x); %digital data (5 bits)
SignalAWG=get(doublePtrA,'Value');
close all
plot(SignalAWG) %forma de la seal a emitir
title('Forma de la seal que se emitir en el Generador de Funciones')
pause
doubleA=0;%DC ofset
longB=1; %1x=0 4x=1
doubleC=50; %impedancia de salida
longC=1; %1=repeat
longD=0;%1 play with trigger
longE=1;% change clocks to perform the generation.
ReturnSetupAWG=calllib('ElabDLL', 'SetupAWG', doublePtrA, int16PtrA, SamplesPlay, doubleA, PlayFrecuency, longB, doubleC, longC, longD, longE);
longA=1;
ReturnAWGStart=calllib('ElabDLL', 'AWGStart', longA);
%poner en marcha la captura de datos
blocknumbers=16;
uintB=1;
uintC=0;
doubleA=0;
uintD=1;
longA=1;
ReturnCaptureDSOData=calllib('ElabDLL', 'CaptureDSOData',blocknumbers, uintB, uintC, doubleA, uintD, longA);
%Descargar datos del ELAB
uintA=1;
x = zeros(blocknumbers*1024, 1);%reserva espacio en memoria 32*1024 "filas" por 3 variables
y = zeros(blocknumbers*1024, 1);
z = zeros(blocknumbers*1024, 1);
doublePtrA = libpointer('doublePtr',x);
doublePtrB = libpointer('doublePtr',y);
uint16PtrA = libpointer('uint16Ptr',z);
uintBA=1;
CapturedSamples=calllib('ElabDLL', 'RetrieveDSOData', uintA, doublePtrA, doublePtrB, uint16PtrA, uintB);

%parar AWG
ReturnAWGStop=calllib('ElabDLL', 'AWGStop');

%Confirmar correcto funcionamiento de los sistemas
if (ReturnSetupAWG==1) & (ReturnAWGStart==1)& (ReturnAWGStop==1)
    disp(' El generador de funciones digital esta configurado correctamente y funciona')
    PlayFrecuency 
    SamplesPlay
else
    disp(' El generador de funciones digital NO esta configurado correctamente')
    return 
end
if ReturnCaptureDSOData
    disp(' Se ha realizado la captura de datos correctamente')
else
    disp(' NO Se ha realizado la captura de datos correctamente')
    return  
end

if (ReturnSetAnalogChannels==0) & (ReturnSetDSODCOffsets==0)& (MuestreoAsignado~=0) & (ReturnCaptureDSOData==1)& (CapturedSamples~=0)
    disp(' El Osciloscopio digital esta configurado correctamente y funciona')
    MuestreoAsignado 
    CapturedSamples
else
    disp(' El Osciloscopio digital NO esta configurado correctamente')
    return 
end
SignalAWG=get(doublePtrA,'Value');

%visualizar datos del DSO
canal1=get(doublePtrA,'Value');
close all
plot(canal1)
grid
xlabel('Muestras')
ylabel('Amplitud')
texto=['Canal 1 con ', num2str(CapturedSamples), ' muestras y frecuencia de muestreo= ', num2str(MuestreoAsignado),'Hz'];
title(texto)
pause
close all
[f,mag] = daqdocfft(canal1,MuestreoAsignado,CapturedSamples);
plot(f,mag)
grid on 
ylabel('Magnitude (dB)')
xlabel('Frequency (Hz)')
title('Frequency Components Ch1')
% unloadlibrary ElabDLL
